                 QLogic FC-FCoE BIOS Release Notes
                       Marvell Corporation
                       All rights reserved

Table of Contents

1. Change History
2. Known Issues
3. Notices
4. Contacting Support


1. Change History

These release notes describe the changes, fixes, known issues, and 
release details that apply to the FC-FCoE BIOS versions 3.00 - 3.67. 

This section contains:

 * 1.1 Version
 * 1.2 Changes
 * 1.3 Bug Fixes


1.1

Version 3.68
* Removed code that disabled CTRL-Q hot key on certain OEM cards.
  This behavior was inadvertently enabled in version 3.65 Beta1.
  The CTRL-Q message is still hidden on certain OEM cards. (FCD-3627)

Version 3.67
* Changed queue alignment to match FW spec queue alignment requirements. 
  9.14.00 FW enforces the queue alignment requirements. (FCD-3507)

Version 3.66
* Just bump the version.
 
Version 3.65
* Removed Beta banner

Version 3.65 Beta 8 
* Fix Compellant target won't be seen issue on certain platform(ER147448)

Version 3.65 Beta 7
* Added check to verify NVRAM Defualts are valid  
	 
Version 3.65 Beta 6	 
* Clean up semaphore lock/unlock code  
* Added support to use new flash region when restoring NVRAM defaults

Version 3.65 Beta 5	 
*  Fixed issue with CLP on Mach adapter

Version 3.65 Beta 4	 
*  Fixed issue with secure flash on Mach HBA
 
Version 3.65 Beta 3	 
* Fixed bug where Mach Novram flag was not saved in Runtime code
 
Version 3.65 Beta 2	  
* Added support for device id 2281h

Version 3.65 Beta 1	  
*  Fixed issue that reset CLP flags (ER145040)
*  Add support for Mach HBA                            

Version 3.64 
* Fixed issue with updating CTRL-Q saving options when Secure Flash present (ER144153.
      
Version 3.63 
* Removed Beta banner

Version 3.63 Beta 1
*  Fixed issue with Secure Flash (ER143508).
 
Version 3.62 
* Removed Beta banner
 
Version 3.62 Beta 1
* Added code to load seperate BIOS image for QME27xx and QME269x.                                       
* Removed Loop Only option in CTRL -Q when only Max data rate available (ER143180).                      
 
Version 3.61 
* Removed Beta banner

Version 3.61 Beta 4
* Fixed set Linkspeed CLP issue setting 4Gbs data rate 
* Fized potential issue with set permanentAddress CLP. 

Version 3.61 Beta 3
* Changed code to handle set MD2 CLP when BDF is set to '0'.   
* Added check for invalid CLP LUN.
* Added code to not enable BIOS when Port Disabled is set.

Version 3.61 Beta 2
* Add check for valid data rate value for CLP set PortLinkSpeed.(ER142810)    
* Changed CLP return status to send CR, LF.   

Version 3.61 Beta 1
* Changed code to return error status when CLP hssreg sent to HBA (ER142725). 
* Changed code to reset all CLP's when no CLP's sent on reboot.

Version 3.60
* Fixed bug created in version 3.59 that cause BFS to fail (ER142668). 

Version 3.59
* Fixed CTRL-Q cosmetic issue when displing bbcr option.
* Added code to update 'set' CLP Response buffer.
* Fixed potential issue when updating BBCR parameters (ER142355). 

Version 3.58
* Fixed bug in setting FEC Training Flag. ER142288

Version 3.57 
* Remove Beta Banner

Version 3.57 Beta 2
* Fixed bug in displaying Data Rate. ER142244    

Version 3.57 Beta 1
* Added back code to check semaphore lock for NVRAM read. ER141633                                              
* Removed support for LR option from CTRL-Q. ER141885 
* Added support for CLP set/show portenable.      

Version 3.56
* Remove Beta Banner

Version 3.56 Beta 2
* Fixed CTRL-Q cosmetic issue when updating LR option.             
* Added support for additional "show CLP's".

Version 3.56 Beta 1
* Added support for Quadium - Secure flash.
 
Version 3.55 
* Added code to load a separate BIOs for each OEM Mezz card.           
* Added Baker/Qlipper OEM Warm/Cold boot detection.

Version 3.54 
* Fixed bug that could cause CLP 'set netport' to not be processed correctly. 
  
Version 3.54 Beta 1
* Check for ER141541 condition
  
Version 3.53
* Minor cosmetic change to CTRL-Q Data Rate Menu

Version 3.52
* Fixed bug in displaying Minimum Data Rate

Version 3.51 
* Removed Beta Banner

Version 3.51 Beta 3
* Added code to support setting Minimum Speed.

Version 3.51 Beta 2
*  Fixed bug in displaying CLP LUN (ER140948).

Version 3.51 Beta 1
*  Added code to load separate BIOS for Yarmouth and Aquinnah adapter (ER140669).           

Version 3.50 
* Removed Beta banner

Version 3.50 Beta 1
* Added support for Additional Receive Credits option.
* Removed code to display IRQ in CTRL-Q.           
* Fix issue to display "FCoE" BIOS Banner for FCoE adapters (ER 140014). 
* Add support for OEM Set/Show CLP's                       


Version 3.43
* Fixed bug that caused FlexAddress to fail on Hilda adapters (ER139777).

Version 3.42
* Added delay before issuing zone command to get FA-BLUN (ER139690).

Version 3.41 
*  Added code to to allow direct connected LUN to be configured when FA_BLUN is enabled.   

Version 3.40 
* Removed Beta Banner

Version 3.40 Beta 3
* Added code to check for Embedded HBA flag in FBC to determine setting of Training Enable bit.

Version 3.40 Beta 2
* Changed code to check for selectable boot when FA_BLUN not found.   

Version 3.40 Beta 1
* Added support for configuring FEC and BB_CR.
* Fixed issue in check_mem64 routine where pci address was not setup correctly.

Version 3.39 
* Fixed issue with 64bit addressing when BIOS enabled (ER138735).

Version 3.38 
* Removed Beta Banner

Version 3.38 Beta 1
* Added code for load separate BIOS image for QLE27xx and QLE269x.(ER138517)
* Disabled CTRL-C option for BIOS setup utility (ER139677) 

Version 3.37
* Added code to restore Virtual WWPN after cold boot for Baker based HBA's (ER138315).

Version 3.36 
* Fixed bug created in BIOS 3.35 that caused BFS to fail (ER138533, ER138536). 

Version 3.35
* Removed code that was preventing alternate FW from loading (ER138425).

Version 3.34
* Fixed issue with Show CLP Hilda FC pointer. (ER138211) 

Version 3.33 
* Fixed CTRL-Q utility datarate menu for Hilda HBA. (ER138168)    

Version 3.32 
* Removed Beta Banner

Version 3.32 Beta 2
* Fixed bug in setting pointer for secondary FW (ER137883). 

Version 3.32 Beta 1
* Added support for QLipper  
 
Version 3.31 
* Removed Beta Banner
Version 3.31 Beta 2
* Added back Spin-up delay. (FOR DEBUG USE ONLY) (ER136488) 
* Fixed issue with OCSD (ER136720) 

Version 3.31 Beta 1
* Fixed bug in setting pointer for NVRAM access. This 
*  bug was created in version 3.30.              

Version 3.30 
* Removed Beta Banner
Version 3.30 Beta 1
* Added code to check for CTRL-Q disabled(ER135448).   
* Added code to allow 4G data rate for 26xx(ER135693).
* Added check for which copy of FW to use (Baker only).
* Fixed issue with supporting 64bit Bar(ER136098).  

Version 3.29 
* Fixed issue causing MD2 CLP to fail (ER135507).
Version 3.29 Beta 2
* Added code to fix CLP issue with 13G Dell system
Version 3.29 Beta 1
* Fixed bug in displaying Execution Throttle in CTRL-Q utility correctly for 4/8G HBA.       
Version 3.28 
* Removed Beta Banner
Version 3.28 Beta 2
* Added coded to load/start FW for OCBB/OCSD only when BIOS is disabled
Version 3.28 Beta 1
* Added support of Baker HBA
Version 3.27
* Added code to not configure any targets when FA Boot
*  LUN enabled but FA BOOT LUN not found. ER133769.    
* Added code to allow FA Boot LUN when FA WWPN enabled
* Added options in CTRL-Q utility to enable FA WWPN   
*  and FA BOOT LUN.                                    

Version 3.26
* Fix minor cosmetic error in display of Fcode/EFI   
*  versions for show port CLP. (ER133294)               
* Added support FA BOOT LUN                             
* Added 8G support for show port clp                  

Version 3.25
* Removed Beta Banner

Version 3.25 Beta 2    
* Changed VLAN ID max value from 4095 to 4094.        
* Removed spinup option from CTRL-Q.                  
* Changed CTRL-Q to allow max value for Login Retry, 
* Port Down Retry, Link Down Count of 65535.ER(116099)
* Removed Helga support                               
* Added support for show port clp.                    

Version 3.25 Beta 1
* Remove EV boot order option from OEM BIOS.
* Added CTRL-Q option to set VLAN_ID for FCoE HBA's(ER110593). 

Version 3.24
* Removed Beta Banner

Version 3.24 Beta 1
Changed Banner to display 'FCoE' for Schultz (ER110784).                         
Added additional time to login target when called   
after EFI driver unloads. (ER110755, ER110855)       

Version 3.23 
* Removed Beta Banner

Version 3.23 Beta 2    
Added code to handle boot LUN Greater Than 255 (ER109195).

Version 3.23 Beta 1
* Added support for Helga.

Version 3.22
* Added code to display message when 64 bit address is detected.

Version 3.21 
* Removed Beta Banner

Version 3.21 Beta 1
* Added support for Execution Throttle for P3P (ER106372)
* Added code to not display connection options for Hilda Trinity adapter.                              
* Checked for invalid LUN in CTRL-Q scan devices.           

Version 3.20 
* Fixed bug in CTRL_Q utility that could cause some cosmetic display issues.                  
* Added Hilda CLP _hss support.                        
* Configured ISP24xx if on slot 0.                  
* Added "QLogic" to PnP productid (ER104424)         
* Checked for 4G flag in NVRAM for Hilda FC. (ER104714)  

Version 3.19 
* Removed Beta Banner

Version 3.19 Beta 1
* Fixed bug with CTRL-Q Loopback Utility (ER100729).  

Version 3.18 
* Removed Beta Banner

Version 3.18 
* Added code to check/program Feature Config checksum.   
* Fixed bug that could cause buffer overrun in CTRL-Q with Report Lun command (ER100294).                 
* Added check for PCI address change when updating option card data structure.                      

Version 3.18 Beta 1 
* Changed code to use 32 bit pointer to allocate/deallocate EBDA memory.
* Added code to check/program Feature Config checksum.

Version 3.17 
* Removed Beta Banner

Version 3.17 Beta 1
*  Fixed cosmetic issue in displaying data rate in CTRL-Q

Version 3.16
* Changed text for 8300 series adapters External loopback (ER98690). 
* Fixed display issue with CTRL-Q Diskutility(ER98727)
* Fixed Lun select issue with CTRL-Q (ER98675).       

Version 3.15
* Removed Beta Banner

Version 3.14 Beta 3
* Fixed bug in displaying selectable boot lun (ER98226)                                         
* Removed 4G data rate option for OEM adapter (ER98228)   
* Limited leading '0's in CTRL-Q menu (ER98389).       
* Set 'Aggressive Cooling' flag for OCSD.            
* Enabled Personality Change option.              

Version 3.14 Beta 2
* Fixed issue with not restoring defaults on port 1 (ER 97619)
* Fixed issue with serdes data saved incorrectly.   (ER 97654)                                      
* Added code to limit Report Lun List size to 256 luns
Version 3.14 Beta 1
*  Added check for 0 lun count when selecting device (ER 97385)
Version 3.14
* Removed 'Beta' from banner
Version 3.13 Beta 17
* Disabled Personality Change option in CTRL-Q.                  
* Fixed bug with WWNN handling for MCTP. (ER 96920)
Version 3.13 Beta 16   
* Added check for Set MD2 set to 0 (restore defaults) (ER96912)
* Added code to reset Port Config after Internal 
  loopback test for 8300 series adapter(FCoE).                      
Version 3.13 Beta 15   
* Added support for 16 bit lun (ER96090). 
Version 3.13 Beta 14
* Added support for Set MD2 CLP string.                 
Version 3.13 Beta 13
* Added code to issue Load Flash FW (3) MB command for
  8300 series adapter as part ISP start sequence. (ER 94035).       
Version 3.13 Beta 12
* Fixed code to prevent async event from causing BIOS 
  to hang when scanning for devices (ER94371).
* Added check for Internal Loopback mode when         
  connected to F-Port (ER71773).                      
* Added check for 8300 series adapter FW Auto Load when re-initing ISP.                                                *
Version 3.13 Beta 11
* Fixed code to disable ALT+1 Hotkey (ER92844).        
* Fixed CTRL-Q code mailbox timeout (ER92957).        
Version 3.12 Beta 10
* Added warning message in Personality change screen
Version 3.12 Beta 9
* Updated BIOS to version 3.12 of non-8300 series adapter BIOS
Version 3.12 Beta 8
* Updated 8300 series adapter BIOS code with version 3.11 fixes 
		
Version 3.11  
* Removed check for Virtual Address flag on Cold Boot. 
    
Version 3.10 
* Changed code to check for signature aaaaaaaah before*
  updating virtual mac address.                       

 Version 3.09
* Changed code to ignore soft boot signature aaaaaaaah*

Version 3.08                                               
*  Added code to save device number in OCSD. 
          
Version 3.07
 * Added code to read cold boot register signature to  
   determine when BIOS should update/restore virtual   
   Mac address.
                                              
Version 3.06
 * Fixed bug where retry count was not always being updated. 

Version 3.05
 * Added code to support ECHO loopback command.
         
Version 3.04
 * Removed Beta from banner.
                     
Version 3.04 Beta 4
 * Fixed bug in clp_hss processing.                     
 * Updated some ETOC header data fields. 
              
Version 3.04 Beta 3:
 * Changed code passing Sensor Data pointer

Version 3.04 Beta 2
 * Added support for passing ETOC pointer.             
 * Added support for posting port status for EFI use. 
 
Version 3.04 Beta 1
 * Added support for sensor data reporting.
    
Version 3.03
 * Added support NCSI Flex Address.    
                
Version 3.02
 * Fixed bug in setting mailbox timeout for TUR. 
 
Version 3.01
 * Removed CTRL-Q Loopback test for P3P.  
      
Version 3.00
 * Removed Beta banner	

Version Beta 14
 * Added code to get serial number from VPD data for ISP2532.
 * Fixed bug in display loopback error status. 
            
Version Beta 13 
 * Fixed bug in verifying FW for non-P3P HBA's.          
 * Removed QLogic vendor id from BIOS banner.            
 * Added retry for LLIOCB when status subcode is 4.  

Version Beta 12 
 * Fixed bug in not setting up retry count for P3P. 

Version Beta 11
 * Added support for -LR option                       
 * Changed error message when no ISP Functions found. 

Version Beta 10
 * Added code to check for Wocket card.    
        
Version Beta 9
 * Fixed bug with not clearing P3 Async Event.
         
Version Beta 8
 * Added additional check for P3 INIT Complete. 
       
Version Beta 7
 * Increased p3_busy_wait delay 

1.2 Changes

The following changes have been made to the BIOS for FC-FCoE 
Adapters between versions 3.02 and 3.68.

* Removed code that disabled CTRL-Q hot key on certain OEM cards.
  This behavior was inadvertently enabled in version 3.65 Beta1.
  The CTRL-Q message is still hidden on certain OEM cards. (FCD-3627)
* Changed queue alignment to match FW spec queue alignment requirements. 
  9.14.00 FW enforces the queue alignment requirements. (FCD-3507)
* Added check to verify NVRAM Defualts are valid  
* Clean up semaphore lock/unlock code  
* Added support to use new flash region when restoring NVRAM defaults
* Added code to support Mach HBA
* Added code to load seperate BIOS image for QME27xx and QME269x.                                       
* Removed Loop Only option in CTRL -Q when only Max data rate available (ER143180).                      
* Changed code to handle set MD2 CLP when BDF is set to '0'.   
* Added check for invalid CLP LUN.
* Added code to not enable BIOS when Port Disabled is set.
* Changed CLP return status to send CR, LF.   
* Changed code to return error status when CLP hssreg sent to HBA (ER142725). 
* Changed code to reset all CLP's when no CLP's sent on reboot.
* Added code to update 'set' CLP Response buffer.
* Added back code to check semaphore lock for NVRAM read. ER141633                                              
* Removed support for LR option from CTRL-Q. ER141885 
* Added support for CLP set/show portenable.      
* Fixed CTRL-Q cosmetic issue when updating LR option.             
* Added support for additional "show CLP's".
* Added support for Quadium - Secure flash.
* Added code to load a separate BIOs for each Mezz card (Huawei only).           
* Added Baker/Qlipper Warm/Cold boot detection (Huawei only).
* Fixed bug that could cause CLP 'set netport' to not be processed correctly. 
* Check for ER141541 condition
* Minor cosmetic change to CTRL-Q Data Rate Menu
* Fixed bug in displaying Minimum Data Rate
* Added code to support setting Minimum Speed.
* Added support for Additional Receive Credits option.
* Removed code to display IRQ in CTRL-Q.           
* Fix issue to display "FCoE" BIOS Banner for FCoE adapters (ER 140014). 
* Add support for OEM Set/Show CLP's                       
* Added delay before issuing zone command to get FA-BLUN (ER139690).
* Added code to to allow direct connected LUN to be configured when FA_BLUN is enabled.   
* Added code to check for Embedded HBA flag in FBC to determine setting of Training Enable bit.
* Changed code to check for selectable boot when FA_BLUN not found.   
* Added support for configuring FEC and BB_CR.
* Fixed issue in check_mem64 routine where pci address was not setup correctly.
* Added code for load separate BIOS image for QLE27xx and QLE269x.(ER138517)
* Added code to restore Virtual WWPN after cold boot for Baker based HBA's (ER138315).
* Removed code that was preventing alternate FW from loading (ER138425).
* Fixed issue with Show CLP Hilda FC pointer. (ER138211) 
* Fixed CTRL-Q utility datarate menu for Hilda HBA. (ER138168)    
* Fixed bug in setting pointer for secondary FW (ER137883). 
* Added support for QLipper  
* Added back Spin-up delay. (FOR DEBUG USE ONLY) (ER136488) 
* Fixed issue with OCSD (ER136720) 
* Fixed bug in setting pointer for NVRAM access. This 
*  bug was created in version 3.30.  (ER136873)             
* Fixed issue causing MD2 CLP to fail (ER135507).
* Added code to fix CLP issue with 13G Dell system
* Fixed bug in displaying Execution Throttle in CTRL-Q utility correctly for 4/8G HBA.       
* Added coded to load/start FW for OCBB/OCSD only when BIOS is disabled
* Added support of Baker HBA
* Added code to not configure any targets when FA Boot
*  LUN enabled but FA BOOT LUN not found. ER133769.    
* Added code to allow FA Boot LUN when FA WWPN enabled
* Added options in CTRL-Q utility to enable FA WWPN   
*  and FA BOOT LUN.                                    
* Fix minor cosmetic error in display of Fcode/EFI   
*  versions for show port CLP. (ER133294)               
* Added support FA BOOT LUN       
* Added 8G support for show port clp                  
* Changed VLAN ID max value from 4095 to 4094.        
* Removed spinup option from CTRL-Q.                  
* Changed CTRL-Q to allow max value for Login Retry, 
* Port Down Retry, Link Down Count of 65535.ER(116099)
* Removed Helga support                               
* Added support for show port clp.                    
 * Remove EV boot order option from OEM BIOS.
 * Added CTRL_Q option to set VLAN_ID for FCoE HBA's(ER110593). 
 * Changed Banner to display 'FCoE' for Schultz (ER110790).                         
 * Added additional time to login target when called   
 *  after EFI driver unloads. (ER110755.ER110855)       
 * Added support for Helga.
 * Added code to display message when 64 bit address is detected.
 * Added support for Execution Throttle for P3P (ER106372)
 * Added code to not display connection options for Hilda Trinity adapter.                              
 * Checked for invalid LUN in CTRL-Q scan devices.           
 * Fixed bug in CTRL_Q utility that could cause some cosmetic display issues.                  
 * Added Hilda CLP _hss support.                        
 * Configured ISP24xx if on slot 0.                  
 * Added "QLogic" to PnP productid (ER104424)         
 * Checked for 4G flag in NVRAM for Hilda FC. (ER104714)  
 * Fixed bug with CTRL-Q Loopback Utility (ER100729). 
 * Added code to check/program Feature Config checksum.   
 * Fixed bug that could cause buffer overrun in CTRL-Q with Report Lun command (ER100294).                 
 * Added check for PCI address change when updating option card data structure.                      
 * Changed code to use 32 bit pointer to allocate/deallocate EBDA memory.
 * Added code to check/program Feature Config checksum.
 * Fixed cosmetic issue in displaying data rate in CTRL-Q
 * Changed text for Hilda External loopback (ER98690). 
 * Fixed display issue with CTRL-Q Diskutility(ER98727)
 * Fixed Lun select issue with CTRL-Q (ER98675).       
 * Fixed bug in displaying selectable boot lun (ER98226)                                         
 * Removed 4G data rate option for OEM adapter (ER98228)   
 * Limited leading '0's in CTRL-Q menu (ER98389).       
 * Set 'Aggressive Cooling' flag for OCSD.            
 * Enabled Personality Change option.              
 * Fixed issue with not restoring defaults on port 1 (ER 97619)
 * Fixed issue with serdes data saved incorrectly.   (ER 97654)                                      
 * Added code to limit Report Lun List size to 256 luns
 *  Added check for 0 lun count when selecting device (ER 97385)
 * Disabled Personality Change option in CTRL-Q.                  
 * Fixed bug with WWNN handling for MCTP. (ER 96920)
 * Added check for Set MD2 set to 0 (restore defaults) (ER96912)
 * Added code to reset Port Config after Internal 
   loopback test for Hilda(FCoE).                      
 * Added support for 16 bit lun (er96090). 
 * Add support for Set MD2 CLP string.                 
 * Added code to issue Load Flash FW (3) MB command for
   Hilda as part ISP start sequence. (ER 94035).       
 * Fixed code to prevent async event from causing BIOS 
   to hang when scanning for devices (er94371).
 * Fixed code to disable ALT+1 Hotkey (er92844).        
 * Fixed CTRL-Q code mailbox timeout (er92957).        
 * Added warning message in Personality change screen.
 * Updated BIOS to version 3.12 of non-hilda BIOS
 * Removed check for Virtual Address on Cold Boot.     
 * Changed code to check for signature aaaaaaaah before
   updating virtual mac address.                  
 * Changed code to ignore soft boot signature aaaaaaaah
 * Added code to save device number in OCSD.
 * Added code to read cold boot register signature to  
   determine when BIOS should update/restore virtual   
   Mac address.                                              
 * Fixed bug where retry count was not always being updated. 
 * Added code to support ECHO loopback command.         
 * Added support NCSI Flex Address. 

1.3 Bug Fixes

The following fixes have been made to the BIOS for FC-FCoE 
Adapters between versions 3.00 Beta 7 and 3.68. 

 * Removed code that disabled CTRL-Q hot key on certain OEM cards.
   This behavior was inadvertently enabled in version 3.65 Beta1.
   The CTRL-Q message is still hidden on certain OEM cards. (FCD-3627)
 * Changed queue alignment to match FW spec queue alignment requirements. 
   9.14.00 FW enforces the queue alignment requirements. (FCD-3507)
 * Fixed issue with CLP on Mach adapter
 * Fixed issue with updating CTRL-Q saving options when Secure Flash present (ER144153.
 * Fixed issue with Secure Flash (ER143508).
 * Fixed set Linkspeed CLP issue setting 4Gbs data rate 
 * Fized potential issue with set permanentAddress CLP. 
 * Add check for valid data rate value for CLP set PortLinkSpeed. (ER142810)    
 * Changed code to return error status when CLP hssreg sent to HBA (ER142725). 
 * Fixed bug created in version 3.59 that cause BFS to fail (ER142668). 
 * Fixed CTRL-Q cosmetic issue when displing bbcr option.
 * Fixed potential issue when updating BBCR parameters (ER142355). 
 * Fixed bug in setting FEC Training Flag. ER142288
 * Fixed bug in displaying Data Rate. ER142244    
 * Fixed CTRL-Q cosmetic issue when updating LR option.             
 * Fixed bug that could cause CLP 'set netport' to not be processed correctly. 
 * Check for ER141541 condition
 * Fixed bug in displaying Minimum Data Rate
 * Fixed bug in displaying CLP LUN (ER140948).
 * Added code to load separate BIOS for Yarmouth and Aquinnah adapter (ER140669).           
 * Fix issue to display "FCoE" BIOS Banner for FCoE adapters (ER 140014). 
 * Fixed bug that caused FlexAddress to fail on Hilda adapters (ER139777).
 * Added delay before issuing zone command to get FA-BLUN (ER139690).
 * Added code to to allow direct connected LUN to be configured when FA_BLUN is enabled.   
 * Fixed issue in check_mem64 routine where pci address was not setup correctly.
 * Fixed issue with 64bit addressing when BIOS enabled (ER138735).
 * Added code to restore Virtual WWPN after cold boot for Baker based HBA's (ER138315).
 * Fixed bug created in BIOS 3.35 that caused BFS to fail (ER138533, ER138536). 
 * Removed code that was preventing alternate FW from loading (ER138425).
 * Fixed issue with Show CLP Hilda FC pointer. (ER138211) 
 * Fixed CTRL-Q utility datarate menu for Hilda HBA. (ER138168)    
 * Fixed bug in setting pointer for secondary FW (ER137883). 
 * Added back Spin-up delay. (FOR DEBUG USE ONLY) (ER136488) 
 * Fixed issue with OCSD (ER136720) 
 * Fixed bug in setting pointer for NVRAM access. This 
 *  bug was created in version 3.30.  (ER136873)            
 * Fixed issue causing MD2 CLP to fail (ER135507).
 * Fixed bug in displaying Execution Throttle in CTRL-Q utility correctly for 4/8G HBA.       
 * Added coded to load/start FW for OCBB/OCSD only when BIOS is disabled
 * Added code to not configure any targets when FA Boot
 *  LUN enabled but FA BOOT LUN not found. ER133769.    
 * Added code to allow FA Boot LUN when FA WWPN enabled
 * Fix minor cosmetic error in display of Fcode/EFI   
 *  versions for show port CLP. (ER133294)               
 * Added support FA BOOT LUN.        
 * Changed CTRL-Q to allow max value for Login Retry, 
 * Port Down Retry, Link Down Count of 65535.ER(116099)
 * Changed Banner to display 'FCoE' for Schultz (ER110790).                         
 * Added additional time to login target when called   
 *  after EFI driver unloads. (ER110755.ER110855)       
 * Added code to handle boot LUN Greater Than 255 (ER109195).
 * Checked for invalid LUN in CTRL-Q scan devices.           
 * Fixed bug in CTRL_Q utility that could cause some cosmetic display issues.                  
 * Added Hilda CLP _hss support.                        
 * Configured ISP24xx if on slot 0.                  
 * Added "QLogic" to PnP productid (ER104424)         
 * Checked for 4G flag in NVRAM for Hilda FC. (ER104714)  
 * Fixed bug with CTRL-Q Loopback Utility (ER100729). 
 * Added code to check/program Feature Config checksum.   
 * Fixed bug that could cause buffer overrun in CTRL-Q with Report Lun command (ER100294).                 
 * Added check for PCI address change when updating option card data structure.                      
 * Changed code to use 32 bit pointer to allocate/deallocate EBDA memory.
 * Added code to check/program Feature Config checksum.
 * Fixed cosmetic issue in displaying data rate in CTRL-Q
 * Changed text for Hilda External loopback (ER98690). 
 * Fixed display issue with CTRL-Q Diskutility(ER98727)
 * Fixed Lun select issue with CTRL-Q (ER98675).       
 * Fixed bug in displaying selectable boot lun (ER98226)                                         
 * Removed 4G data rate option for OEM adapter (ER98228)   
 * Limitleading '0's in CTRL-Q menu (ER98389).       
 * Set 'Aggressive Cooling' flag for OCSD.            
 * Fixed issue with not restoring defaults on port 1 (ER 97619)
 * Fixed issue with serdes data saved incorrectly.   (ER 97654)                                      
 * Added code to limit Report Lun List size to 256 luns
 *  Added check for 0 lun count when selecting device (ER 97385)
 * Disabled Personality Change option in CTRL-Q.                  
 * Fixed bug with WWNN handling for MCTP. (ER 96920)
 * Added check for Set MD2 set to 0 (restore defaults) (ER96912)
 * Added support for 16 bit lun (er96090). 
 * Add support for Set MD2 CLP string.                 
 * Added code to issue Load Flash FW (3) MB command for
   Hilda as part ISP start sequence. (ER 94035).       
 * Fixed code to prevent async event from causing BIOS 
   to hang when scanning for devices (er94371).
 * Fixed code to disable ALT+1 Hotkey (er92844).        
 * Fixed CTRL-Q code mailbox timeout (er92957).        
 * Added warning message in Personality change screen.
 * Updated BIOS to version 3.12 of non-hilda BIOS
 * Removed check for Virtual Address on Cold Boot.     
 * Changed code to check for signature aaaaaaaah before
   updating virtual mac address.                  
 * Changed code to ignore soft boot signature aaaaaaaah
 * Added code to save device number in OCSD.
 * Added code to read cold boot register signature to  
   determine when BIOS should update/restore virtual   
   Mac address.                                              
 * Fixed bug where retry count was not always being updated.
 * Added code to support ECHO loopback command.         
 * Fixed bug in clp_hss processing.
 * Updated some ETOC header data fields.
 * Changed code passing Sensor data pointer
 * Added support for passing ETOC pointer.             
 * Added support for posting port status for EFI use.  
 * Added support for sensor data reporting.    
 * Added support NCSI Flex Address.                    
 * Fixed bug in setting mailbox timeout for TUR.  
 * Increased p3_busy_wait delay                         
 * Added additional check for P3 INIT Complete.        
 * Fixed bug with not clearing P3 Async Event.         
 * Added code to check for Wocket card.               
 * Added support for -LR option                       
 * Changed error message when no ISP Functions found. 
 * Fixed bug in not setting up retry count for P3P. 
 * Fixed bug in verifying FW for non-P3P HBA's.          
 * Removed QLogic vendor id from BIOS banner.            
 * Added retry for LLIOCB when status subcode is 4.  
 * Added code to get serial number from VDP data for ISP2532.                                           
 * Fixed bug in display loopback error status.             
 * Fixed bug in setting mailbox timeout for TUR.                    

   	   											
2. Known Issues 

None
   

3. Notices

Information furnished in this document is believed to be accurate and
reliable. However, Cavium Corporation assumes no responsibility for
its use, nor for any infringements of patents or other rights of
third parties which may result from its use. Cavium Corporation
reserves the right to change product specifications at any time
without notice. Applications described in this document for any of
these products are only for illustrative purposes. Cavium Corporation
makes no representation nor warranty that such applications are
suitable for the specified use without further testing or
modification. Cavium Corporation assumes no responsibility for any
errors that may appear in this document.


4. Contacting Support

   For further assistance, contact Cavium Technical Support at:
   http://support.cavium.com


Trademarks 

Accelera, Accelerating Cluster Performance, InfiniCon Systems, 
InfiniNIC, InfiniPath, InfiniView, QLA, Cavium, the Cavium logo, 
ReadyPath, SANdoctor, SANsurfer, and SilverStorm are registered 
trademarks of Marvell Corporation. All other brand and product names 
are trademarks or registered trademarks of their respective owners. 


(c) Copyright 2023 All rights reserved worldwide. QLogic, the QLogic
logo, and the Powered by QLogic logo are registered trademarks of
Marvell Corporation. All other brand and product names are trademarks
or registered trademarks of their respective owners.
